version: '3.2'

services:
  backend:
    image: registry.gitlab.com/freelance5421009/saya/backend:latest
    ports:
      - '5000:5000'
    environment:
      MONGO_HOST: mongodb
      MONGO_PORT: 27017
      MONGODB_USERNAME: admin
      MONGODB_PASSWORD: 12345
    networks:
      - bus-network
    deploy:
      mode: replicated
      replicas: 1
      restart_policy:
        condition: on-failure
        delay: 5s
        max_attempts: 3
        window: 15s
      resources:
        limits:
          cpus: '0.2'
          memory: 196M
      placement:
        constraints:
          - node.hostname == docker-master-1

  mongodb:
    image: mongo:latest
    ports:
      - '27017:27017'
    environment:
      MONGO_INITDB_ROOT_USERNAME: admin
      MONGO_INITDB_ROOT_PASSWORD: 12345
    networks:
      - bus-network
    deploy:
      mode: replicated
      replicas: 1
      restart_policy:
        condition: on-failure
        delay: 5s
        max_attempts: 6
        window: 15s
      resources:
        limits:
          cpus: '0.2'
          memory: 256M
      placement:
        constraints:
          - node.hostname == database-01
    volumes:
      - mongodb_data:/data/db

networks:
  bus-network:
    driver: overlay
    attachable: true

volumes:
  mongodb_data:
    driver: local
